Index: ui/mainwindow.ui
===================================================================
--- ui/mainwindow.ui	(revision 6b3d3c1bbb46290b77de51eb3bcb573be840c56a)
+++ ui/mainwindow.ui	(revision aaf2113307a1f7e0af077955ae20083a3d6c9128)
@@ -7,6 +7,6 @@
     <x>0</x>
     <y>0</y>
-    <width>491</width>
-    <height>400</height>
+    <width>502</width>
+    <height>407</height>
    </rect>
   </property>
@@ -24,6 +24,6 @@
       <x>0</x>
       <y>0</y>
-      <width>481</width>
-      <height>311</height>
+      <width>287</width>
+      <height>298</height>
      </rect>
     </property>
@@ -100,7 +100,4 @@
           <property name="minimum">
            <number>3</number>
-          </property>
-          <property name="maximum">
-           <number>5</number>
           </property>
           <property name="value">
@@ -208,4 +205,58 @@
        </widget>
       </item>
+      <item>
+       <layout class="QHBoxLayout" name="horizontalLayout">
+        <item>
+         <widget class="QPushButton" name="buttonSaveSolution">
+          <property name="enabled">
+           <bool>false</bool>
+          </property>
+          <property name="cursor">
+           <cursorShape>PointingHandCursor</cursorShape>
+          </property>
+          <property name="statusTip">
+           <string>Save solution to a file</string>
+          </property>
+          <property name="text">
+           <string>Save Solution</string>
+          </property>
+          <property name="icon">
+           <iconset resource="../resources/tspsg.qrc">
+            <normaloff>:/images/icons/filesaveas.png</normaloff>:/images/icons/filesaveas.png</iconset>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <spacer name="horizontalSpacer">
+          <property name="orientation">
+           <enum>Qt::Horizontal</enum>
+          </property>
+          <property name="sizeHint" stdset="0">
+           <size>
+            <width>40</width>
+            <height>20</height>
+           </size>
+          </property>
+         </spacer>
+        </item>
+        <item>
+         <widget class="QPushButton" name="buttonBackToTask">
+          <property name="cursor">
+           <cursorShape>PointingHandCursor</cursorShape>
+          </property>
+          <property name="statusTip">
+           <string>Go back to Task tab</string>
+          </property>
+          <property name="text">
+           <string>Back to Task</string>
+          </property>
+          <property name="icon">
+           <iconset resource="../resources/tspsg.qrc">
+            <normaloff>:/images/icons/back.png</normaloff>:/images/icons/back.png</iconset>
+          </property>
+         </widget>
+        </item>
+       </layout>
+      </item>
      </layout>
     </widget>
@@ -217,5 +268,5 @@
      <x>0</x>
      <y>0</y>
-     <width>491</width>
+     <width>502</width>
      <height>22</height>
     </rect>
@@ -232,5 +283,5 @@
     <widget class="QMenu" name="menuFileSaveAs">
      <property name="title">
-      <string>Save &amp;As...</string>
+      <string>Save &amp;As</string>
      </property>
      <property name="icon">
@@ -379,9 +430,12 @@
     <string>&amp;Solution...</string>
    </property>
+   <property name="iconText">
+    <string>Solution...</string>
+   </property>
    <property name="toolTip">
     <string>Save solution</string>
    </property>
    <property name="statusTip">
-    <string>Save solution steps and graph</string>
+    <string>Save solution to a file</string>
    </property>
   </action>
@@ -457,4 +511,7 @@
     <string>Open help contents</string>
    </property>
+   <property name="shortcut">
+    <string>Ctrl+F1</string>
+   </property>
   </action>
   <action name="actionHelpContextual">
@@ -472,4 +529,7 @@
     <string>Open context help</string>
    </property>
+   <property name="shortcut">
+    <string>F1</string>
+   </property>
   </action>
   <action name="actionHelpAbout">
@@ -512,7 +572,4 @@
    <property name="statusTip">
     <string>Save task to file</string>
-   </property>
-   <property name="shortcut">
-    <string>Ctrl+S</string>
    </property>
   </action>
@@ -542,14 +599,11 @@
    </property>
    <property name="text">
+    <string notr="true">&amp;English</string>
+   </property>
+   <property name="iconText">
     <string notr="true">English</string>
    </property>
-   <property name="iconText">
-    <string notr="true">English</string>
-   </property>
   </action>
   <action name="actionFileSave">
-   <property name="enabled">
-    <bool>false</bool>
-   </property>
    <property name="icon">
     <iconset resource="../resources/tspsg.qrc">
@@ -567,4 +621,7 @@
    <property name="statusTip">
     <string>Save current task</string>
+   </property>
+   <property name="shortcut">
+    <string>Ctrl+S</string>
    </property>
   </action>
@@ -605,4 +662,20 @@
    </hints>
   </connection>
+  <connection>
+   <sender>buttonSaveSolution</sender>
+   <signal>clicked()</signal>
+   <receiver>actionFileSaveAsSolution</receiver>
+   <slot>trigger()</slot>
+   <hints>
+    <hint type="sourcelabel">
+     <x>58</x>
+     <y>327</y>
+    </hint>
+    <hint type="destinationlabel">
+     <x>-1</x>
+     <y>-1</y>
+    </hint>
+   </hints>
+  </connection>
  </connections>
 </ui>
